<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsjoomla4 extends JPlugin
{
	function plgAnalyticsjoomla4( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
    function onGetChartTypes(&$data, $name) 
	{
		if ( $name != 'joomla4' ) return;
		
		$data = array( 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
			
		if($name != 'joomla4') return;

		global $mainframe;

	    if( !JComponentHelper::isEnabled('com_content', true) ) {
			$errors = '<h3>Core Joomla Content Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[<b>Top articles by sections</b>]]>",15 ,25 , array('text_size' => 16));
	}
	
    function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'joomla4' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label" '.($key == 'category' ? 'valign="top"' : '').'><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'joomla4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$sections  = $params->get( 'sections' );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$max       = $params->get( 'max', 20 );
		$reverse   = $params->get( 'reverse', 'DESC' );

		if( !$sections ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}
		
		$sql = "   SELECT i.id,i.title,i.hits AS amount 
		FROM #__content AS i "
		."\n      WHERE  i.state =  1 AND i.sectionid IN('".implode( "', '", $sections )."') AND i.created BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND i.created_by = '$user_id'";
		$sql .= " GROUP BY i.id"
		."\n   ORDER BY amount ".$reverse
		."\n      LIMIT 0, ".$max
		;

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

	    foreach ( $result AS $row ) {
			$objChart->addSerie($row->id,$row->title);
			$objChart->addGraph($row->id, $row->title, array($row->id => $row->amount), array( 
					'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
				));
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'joomla4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$sections  = $params->get( 'sections' );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$max       = $params->get( 'max', 20 );
		$reverse   = $params->get( 'reverse', 'DESC' );
		$limit = $params->get('limit', 0);

		if( !$sections ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}

		$sql = "   SELECT i.id,i.title,i.hits AS amount 
		FROM #__content AS i "
		."\n      WHERE  i.state =  1 AND i.sectionid IN('".implode( "', '", $sections )."') AND i.created BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND i.created_by = '$user_id'";
		$sql .= " GROUP BY i.id"
		."\n   ORDER BY amount ".$reverse
		;
		$sql .= "\n      LIMIT 0, ".($limit ? $limit : $max);

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		$k                  = 0;
		$current_total      = 0;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Article').'</th>';
		$out[] = '<th width="1%">HITs</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		foreach ( $result AS $row ) {
			$slices[$row->id]['name'] = $row->title;
			$slices[$row->id]['amount'] = $row->amount;
		}

		$k = 1;
		$i = 1;
		foreach ( $slices AS $key => $slice )
		{
			$current_total += $slice['amount'];

			$k = 1 - $k;

			$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
			$k, $i, $slice['name'], $slice['amount'] );
			$i++;
		}
		$out[] = sprintf( "<tr class='row%d'><td></td><td nowrap><big><b>%s</b></big></td><td align='right'><big><b>%s</b></big></td></tr>",
				0, JText::_('Total'), $current_total );

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'joomla4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$sections  = $params->get( 'sections' );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );
		$max       = $params->get( 'max', 20 );
		$reverse   = $params->get( 'reverse', 'DESC' );

		if( !$sections ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}

		$sql = "   SELECT sum(i.hits) AS amount, count(i.id) AS count
		FROM #__content AS i "
		."\n      WHERE  i.state =  1 AND i.sectionid IN('".implode( "', '", $sections )."') AND i.created BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND i.created_by = '$user_id'";
				
		$db->setQuery( $sql );
		$result = $db->loadObject();

		if( !$result->amount ) return;
		
		$sql = " SELECT count(i.id) AS count , sum(i.hits) AS amount
		FROM #__content AS i WHERE i.state = 1 ";
		$db->setQuery($sql);
		$total_records = $db->loadObject();
		
		$totals = array();
		
		$text = JText::_('hits');

		$totals[0]['value'] = $total_records->count.' <i>'.JText::_( 'record(s)').'</i>' ;
		$totals[0]['text'] =  JText::_( 'Total in DB' );
		
		$totals[1]['value'] = $result->count.' <i><b>'.JText::_( 'current record(s)' ).'</b></i>';
		$totals[1]['text'] = round($result->count * 100 / $total_records->count, 1).'% '.JText::_('of all records');
		
		$totals[2]['value'] = $total_records->amount;
		$totals[2]['text'] = JText::_('Total').' '.$text;
		
		$totals[3]['value'] = $result->amount.' <i><b>'.JText::_( 'current' ).' '.$text.'</b></i>';
		$totals[3]['text'] = round($result->amount * 100 / $total_records->amount, 1).'% '.JText::_('of all').' '.$text;
		
		return $totals;
	}
}
?>